

# Module bookish_spork #
* [Data Types](#types)
* [Function Index](#index)
* [Function Details](#functions)

<a name="types"></a>

## Data Types ##




### <a name="type-http_status">http_status()</a> ###


<pre><code>
http_status() = non_neg_integer()
</code></pre>

<a name="index"></a>

## Function Index ##


<table width="100%" border="1" cellspacing="0" cellpadding="2" summary="function index"><tr><td valign="top"><a href="#capture_request-0">capture_request/0</a></td><td></td></tr><tr><td valign="top"><a href="#start_server-0">start_server/0</a></td><td>starts http server on a default port.</td></tr><tr><td valign="top"><a href="#start_server-1">start_server/1</a></td><td>starts http server on a particular port.</td></tr><tr><td valign="top"><a href="#stop_server-0">stop_server/0</a></td><td>stops http server.</td></tr><tr><td valign="top"><a href="#stub_request-0">stub_request/0</a></td><td>stubs request with default response
Defult response is 204 No Content without body.</td></tr><tr><td valign="top"><a href="#stub_request-1">stub_request/1</a></td><td>stub request with fun or particular status.</td></tr><tr><td valign="top"><a href="#stub_request-2">stub_request/2</a></td><td>stub request with particular status and content/headers.</td></tr><tr><td valign="top"><a href="#stub_request-3">stub_request/3</a></td><td></td></tr></table>


<a name="functions"></a>

## Function Details ##

<a name="capture_request-0"></a>

### capture_request/0 ###

<pre><code>
capture_request() -&gt; <a href="bookish_spork_request.md#type-bookish_spork_request">bookish_spork_request:bookish_spork_request()</a>
</code></pre>
<br />

<a name="start_server-0"></a>

### start_server/0 ###

<pre><code>
start_server() -&gt; {ok, pid()} | {error, Error::term()}
</code></pre>
<br />

starts http server on a default port

<a name="start_server-1"></a>

### start_server/1 ###

<pre><code>
start_server(Port::non_neg_integer()) -&gt; {ok, pid()} | {error, Error::term()}
</code></pre>
<br />

starts http server on a particular port

<a name="stop_server-0"></a>

### stop_server/0 ###

<pre><code>
stop_server() -&gt; ok
</code></pre>
<br />

stops http server

<a name="stub_request-0"></a>

### stub_request/0 ###

<pre><code>
stub_request() -&gt; {ok, Acceptor::pid()}
</code></pre>
<br />

stubs request with default response
Defult response is 204 No Content without body. With just two headers: Server and Date

<a name="stub_request-1"></a>

### stub_request/1 ###

<pre><code>
stub_request(Fun::function() | <a href="#type-http_status">http_status()</a>) -&gt; {ok, Acceptor::pid()}
</code></pre>
<br />

stub request with fun or particular status

Fun must be <code>fun((<a href="bookish_spork_request.md#type-request">bookish_spork_request:request()</a>) -> <a href="bookish_spork_response.md#type-response">bookish_spork_response:response()</a>)</code>

Example:

```
  stub_request(fun(Request) ->
      case bookish_spork_request:uri(Request) of
          "/bookish/spork" ->
              bookish_spork_response:new(200, <<"Hello">>);
          "/admin/sporks" ->
              bookish_spork_response:new(403, <<"It is not possible here">>)
      end
  end)
```


<a name="stub_request-2"></a>

### stub_request/2 ###

<pre><code>
stub_request(Status::<a href="#type-http_status">http_status()</a>, ContentOrHeaders::binary() | map()) -&gt; {ok, Acceptor::pid()}
</code></pre>
<br />

stub request with particular status and content/headers

<a name="stub_request-3"></a>

### stub_request/3 ###

<pre><code>
stub_request(Status::<a href="#type-http_status">http_status()</a>, Headers::map(), Content::binary()) -&gt; {ok, Acceptor::pid()}
</code></pre>
<br />

